package com.szpg.task;

import com.szpg.db.dao.impl.PgAcuRdcmdDaoImpl;
import com.szpg.db.data.PgAcuRdcmd;
import com.szpg.plc.message.AppCommand;
import com.szpg.plc.message.command.read.ReadO2ValueCommand;
import com.szpg.plc.protocol.DTProtocolInterface;
import com.szpg.plc.protocol.ProtocolFactory;
import com.szpg.plc.server.ACUClient;
import com.szpg.plc.server.ACUClientUtil;
import com.szpg.plc.util.ByteUtil;

public class ReadO2ValueTask implements Runnable {

	private ACUClient client;
	private AppCommand appCommand;

	public ReadO2ValueTask(ACUClient client, AppCommand command) {
		this.client = client;
		this.appCommand = command;
	}

	@Override
	public void run() {
		DTProtocolInterface finspi = ProtocolFactory.getDefaultDTProtocol();
		byte[] content = finspi.messageToBytes(appCommand);
		
		// 发送读取氧气参数内存命令
		ACUClientUtil.getInstance().sendACUCommand(client, content);
		
		ReadO2ValueCommand coCmd = (ReadO2ValueCommand) appCommand;

		// 发送完成之后将命令保存在数据库中
		PgAcuRdcmd cmd = new PgAcuRdcmd();
		cmd.setCmd_type(coCmd.getCommandType());
		cmd.setDest(coCmd.getDestinationId());
		cmd.setMem_area_cd(ByteUtil.binToHexString(new byte[] { coCmd.getMemoryArea() }));
		cmd.setStart_mem_word(coCmd.getStartAddress().substring(0, 4));
		cmd.setStart_mem_bit(coCmd.getStartAddress().substring(4));
		cmd.setCount_word(coCmd.getCountWord());
		cmd.setCount_bit(coCmd.getCountBit());
		cmd.setCount_sensor(coCmd.getCountSensor());
		
		new PgAcuRdcmdDaoImpl().addCmdRecord(cmd);
	}

}
